#!/usr/bin/env python
# -*- coding: latin-1; -*-

from katropton.speedup import *


def speedup_of_one_case(n_samples, ensemble_sizes, quantiles,
                        querylines, use_waves_timers, use_teuchos_timers,
                        per_iteration):
    import matplotlib.pyplot as plt

    file_MC_base_dir = '/Users/kimliegeois/Desktop/katropton_Juelich_tests_M1_assembly_fused_MC_ER_2/'
    # try:
    speedup = compute_speedup(n_samples, ensemble_sizes, file_MC_base_dir,
                              querylines, per_iteration, quantiles,
                              use_waves_timers, use_teuchos_timers, True)

    plot_speedup(speedup, ensemble_sizes, np.arange(0, len(querylines)),
                 'case_', querylines, per_iteration)
    plt.savefig('case_.png', dpi=400)

    save_speedup(speedup, ensemble_sizes, querylines, 'case_')

    R = compute_R(n_samples, ensemble_sizes, file_MC_base_dir, quantiles,
                  True)
    save_R(R, 'case_')
    # except:
    #    print '/Volumes/HD_SONY/CMAME/Plate/katropton_CMAME_tests_plate_MC_case_' + case_id + '  has not all the files'


def main():
    import matplotlib.pyplot as plt

    n_samples = 64
    ensemble_sizes = [1, 8, 16, 32]
    quantiles = [0, 0.33, 0.5, 0.66, 1.]

    querylines = [
        'computeMatrices', 'Belos: Operation Op*x', 'Belos: Operation Prec*x',
        'Belos: DGKS[2]: Orthogonalization',
        'Belos: DGKS[2]: Ortho (Inner Product)',
        'Belos: DGKS[2]: Ortho (Norm)', 'Belos: DGKS[2]: Ortho (Update)',
        'total', 'write results', 'MueLu: Hierarchy: Solve (level=0)',
        'MueLu: Hierarchy: Solve (level=1)',
        'MueLu: Hierarchy: Solve : smoothing (level=0)',
        'MueLu: Hierarchy: Solve : prolongation (level=0)',
        'MueLu: Hierarchy: Solve : residual calculation (level=0)',
        'MueLu: Hierarchy: Solve : restriction (level=0)',
        'MueLu: SimpleSmoother: Apply: total (total)',
        'MueLu: SimpleSmoother: Correction step: Compute rhs (total)',
        'MueLu: SimpleSmoother: Correction step: Solve block 11 (total)',
        'MueLu: SimpleSmoother: Prediction step: Compute rhs (total)',
        'MueLu: SimpleSmoother: Prediction step: Solve block 00 (total)'
    ]
    use_waves_timers = np.array([0, 7, 8], dtype=int)
    use_teuchos_timers = np.array(
        [1, 2, 3, 4, 5, 6, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19], dtype=int)
    per_iteration = [
        False, True, True, False, False, False, False, False, False, True, True, True, True, True, True, True, True, True, True, True
    ]

    speedup_of_one_case(n_samples, ensemble_sizes, quantiles,
                        querylines, use_waves_timers, use_teuchos_timers,
                        per_iteration)


if __name__ == "__main__":
    main()
