#!/usr/bin/env python
# -*- coding: utf-8 -*-

from __future__ import print_function
from __future__ import division
from builtins import str
from builtins import range
from past.utils import old_div
from katropton.eigenvalues import *
import os
import fwk
"""@package docstring
This file is used to loop over cases and samples and plot their mechanical properties and solution fields.
"""

import vtk
import tboxVtk
import tboxVtk.reader as vtkR
import tboxVtk.cutter as vtkC

from katropton.CMAME.model import Compute_QoIs


def main():
    import matplotlib.pyplot as plt

    file_dir = os.path.dirname(__file__)

    file_MC_base_dir = '/Volumes/HD_SEAGATE/CMAME/Plate/MC/katropton_CMAME_tests_plate_MC_MG_all_cases_2/case_6/'
    n_samples = 6400

    QoIs = np.zeros((4, n_samples))

    ensemble_size = 32

    for i in range(0, n_samples):
        i_ensemble = old_div(i, ensemble_size)
        i_sample = np.mod(i, ensemble_size)
        input_MC_file_dir = file_MC_base_dir + str(ensemble_size) + '/' + str(
            i_ensemble) + '/'
        mshName_sample = input_MC_file_dir + 'plate_fused_ast1_s' + str(
            i_sample) + '_0'

        QoIs[:, i] = Compute_QoIs(mshName_sample)

    print(QoIs)

    np.savez('qois_s' + str(ensemble_size), QoIs=QoIs)


if __name__ == "__main__":
    main()
