function [xh,M,x1,xH1,xH,xcc,AH,I_h_H,I_H_h] = twoGridCycle(xh,Ah,bh,omega,nu1,nu2,dimension,display,L,h)

if display
    scrsz = get(groot,'Screensize');
    figure('Position',[1 scrsz(4)/2 scrsz(3) scrsz(4)/2])
    plot([0:h:L],[0;xh;0],'linewidth',3)
    hold on
    box on 
    grid on 
end

I = eye(size(Ah));

n = size(Ah,1);
if dimension == 1 
    [I_h_H,n2] = oneDRestriction(n);
    [I_H_h,n2] = oneDProlongation(n);
end

AH = I_h_H * Ah * I_H_h;

S_nu1 = eye(size(Ah));
if nu1 >= 1
    [xh, S_nu1] = richardsonSmoother(xh,Ah,bh,omega,nu1);
end

x1 = xh;

if display
    plot([0:h:L],[0;xh;0],'linewidth',3)
end

rh = bh - Ah * xh;

rH = I_h_H * rh;

invAH = inv(AH);
deltaH = invAH*rH;

xH1 = I_h_H * xh;
xH = xH1 + deltaH;


xh = xh + I_H_h * deltaH;
max(abs(xh - I_H_h * xH))
%xh = I_H_h * xH;
%xH = I_h_H * xh;
max(abs(invAH*I_h_H*bh))
max(abs(xH))

xcc = xh;

if display
    plot([0:h:L],[0;xh;0],'linewidth',3)
end

S_nu2 = eye(size(Ah));
if nu2 >= 1
    [xh, S_nu2] = richardsonSmoother(xh,Ah,bh,omega,nu2);
end

if display
    plot([0:h:L],[0;xh;0],'linewidth',3)
    hold off
    legend('initial guess','smoothed guess','coars corrected','smoothed corrected' ,'Location','northoutside','Orientation','horizontal')
end

disp '1'
(I-I_H_h*invAH*I_h_H*Ah)*x1
disp '2'
xcc

M = S_nu2*(I-I_H_h*invAH*I_h_H*Ah)*S_nu1;

if display
    rank(I_H_h*AH*I_h_H)
    [V,D] = eig(I_H_h*AH*I_h_H);
    [V,D2] = eig(I-inv(M)*Ah);%eig(I-I_H_h*invAH*I_h_H*Ah);
    d = diag(D);    
    figure('Position',[1 1 scrsz(3)/2 scrsz(4)/3])

    plot(real(d),imag(d),'o','LineWidth',1,...
            'MarkerSize',8,...
            'MarkerEdgeColor','b',...
            'MarkerFaceColor','b');
    box on 
    grid on   
    
    figure('Position',[scrsz(3)/2 1 scrsz(3)/2 scrsz(4)/3])
    edges = [-0.01:0.02:1.01];
    h = histogram(real(d),edges);
%     d0 = find(d < 0.5);
%     d1 = find(d > 0.5);
%     plot([0,1],[length(d0),length(d1)],'o','LineWidth',1,...
%             'MarkerSize',8,...
%             'MarkerEdgeColor','b',...
%             'MarkerFaceColor','b'); 
    box on 
    grid on   
end
end