function d = distancePointPlane(point, plane)
%DISTANCEPOINTPLANE Signed distance betwen 3D point and plane
%
%   D = distancePointPlane(POINT, PLANE)
%   Returns the euclidean distance between point POINT and the plane PLANE,
%   given by: 
%   POINT : [x0 y0 z0]
%   PLANE : [a b c d]
%   D     : scalar  


d = (plane(1)*point(1)+plane(2)*point(2)+plane(3)*point(3)+plane(4))...
    /sqrt(plane(1)^2+plane(2)^2+plane(3)^2);