#!/usr/bin/env python
# -*- coding: latin-1; -*-

import mirrors as m
import tbox
import tbox.gmsh as gmsh

def main():

    loader = gmsh.MeshLoader("mirrors01_ansys.msh",__file__)
    msh = loader.execute()
    pbl = m.Problem(msh,"mechanical",22)
    m.Medium(pbl, "Volume", "TZM",330000,0.36)
    clamped = tbox.Vector3d(1,1,1)
    values_clamped = tbox.Vector3d(0,0,0)
    values_clamped2 = tbox.Vector3d(0,0,100)
    m.uDirichlet(pbl, "M1_S1", "clamped",clamped,values_clamped)
    m.uDirichlet(pbl, "M1_S2", "clamped",clamped,values_clamped)
    m.uDirichlet(pbl, "M1_S3", "clamped",clamped,values_clamped)
    m.uDirichlet(pbl,"HF","moved",clamped,values_clamped2)

    from fwk.wutils import parseargs
    args=parseargs()

    solver = m.Solver(pbl,args.k)
    solver.start()

    if not args.nogui:
        from mirrors.viewer import GUI
        GUI().open( loader.filename )

if __name__ == "__main__":
    main()
