#!/usr/bin/env python
# -*- coding: latin-1; -*-

# Copyright 2020 University of Liège
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.


import numpy as np

def main():

    from params.arnst_ponthot.src import gamma
    from mpl_toolkits.mplot3d import Axes3D
    from matplotlib import cm
    from matplotlib.ticker import LinearLocator, FormatStrFormatter
    import matplotlib.pyplot as plt
    fig = plt.figure()
    ax = fig.gca(projection='3d')

    m_H = 1495.
    sigmaS_H = 1390.
   
    m_S = 396.
    sigmaS_S = 660.

    rho = -0.223

    g_H = np.linspace(1200,1800, 100)
    g_S = np.linspace(250,550, 100)
    loc = 0. 
    
    PDF = gamma.rho_gamma_gamma(g_H,m_H,sigmaS_H,g_S,m_S,sigmaS_S,rho)

    G_H, G_S = np.meshgrid(g_H, g_S)
    #plt.contour(G_H, G_S, PDF)
    ax.contourf(G_H, G_S, PDF, cmap=cm.coolwarm)

    plt.show()
if __name__ == "__main__":
    main()
