/*
 * Copyright 2020 University of Liège
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef WCACHELINE2_H
#define WCACHELINE2_H

#include "tbox.h"
#include "wCache.h"
#include "wSfLine2.h"
#include "wGaussLine2.h"
#include <vector>

namespace tbox
{

/**
 * @brief Cache handling Line2 shape functions and gauss points
 * @authors Romain Boman, Adrien Crovato
 */
class TBOX_API CacheLine2 : public Cache
{
public:
    SfLine2 sf;
    GaussLine2 gauss;

    explicit CacheLine2(int _npg = 2);

    virtual Gauss &getVGauss() override;
};

} // namespace tbox

#endif //WCACHELINE2_H
