/*
 * Copyright 2020 University of Liège
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef WMEMTRI3_H
#define WMEMTRI3_H

#include "tbox.h"
#include "wMem.h"
#include "wTri3.h"

#ifndef SWIG

namespace tbox
{

/**
 * @brief Precalculated values for Tri3
 * @authors Romain Boman, Adrien Crovato
 */
class TBOX_API MemTri3 : public Mem
{
    // Element type
    Tri3 &e;

public:
    explicit MemTri3(Tri3 &_e, size_t _ngp);
    virtual ~MemTri3() {}

    virtual void update(bool sameDim) override;
};

} // namespace tbox

#endif

#endif //WMEMTRI3_H
